<template lang="pug">

  .container(v-loading="pageLoading")
    .block-typical
      el-form.flex-form(
        ref='productForm'
        v-if="inputs.length"
        :model='stateForm'
        :rules="rules")

        el-form-item(
          v-for="item in inputs"
          :key="item.id"
          v-if='item.name !== "photo"'
          :style="elementFormStyle(item)"
          :prop="item.name")

          app-input(
            :placeholder="item.placeholder"
            :model="stateForm[item.name]"
            :name="item.name"
            :id="item.id"
            :label="item.label"
            :type="item.type"
            :prompt="item.prompt"
            :autosize="item.autosize"
            :required="item.required"
            :maxlength="item.maxlength"
            :options='options'
            :toolbarConfig='toolbarConfig'
            @input-value="modelValue")

        el-form-item(
          prop='photo'
          style='min-width: 100%')

          app-uploader(
            label="Фото"
            :photo="product.photo"
            :uploadForm="uploadForm"
            :uploadFormHost="uploadFormHost"
            :readyToShip='readyToShip'
            @success-upload="successUpload"
            @remove-photo="removePhoto"
            @change-photo="changePhoto")

    .activity__block.reverse
      .activity__block-wrapper
        h5 Активность:
        el-switch(
        v-model='product.active'
        active-color="#39D24E"
        :active-value='true'
        :inactive-value='false')

    .activity__block
      router-link.el-button.el-button--info.button(
      :to="{path: '/admin/products'}")
        |Отмена

      el-button.button(
      type="success"
      @click="createNews('productForm')")
        |Сохранить изменения

</template>

<script>
import InputItem from '../../../components/InputItem';
import Uploader from '../../../components/admin/Uploader';

export default {
  layout: 'admin',
  name: 'ProductsItem',
  components: {
    'app-input': InputItem,
    'app-uploader': Uploader
  },
  async asyncData(context) {
    let { data } = await context.$axios.get(
      `/api/v1/products/${context.params.id}`
    );
    return { product: data };
  },
  data() {
    return {
      readyToShip: false,
      uploadFormHost: `${this.$store.state.baseURL}/api/v1/img`,
      uploadForm: {
        path: ''
      },
      options: [],
      inputs: [
        {
          id: 1,
          placeholder: 'Укажите наименование товара',
          model: '',
          label: 'Наименование товара',
          name: 'name',
          required: true,
          prop: [
            {
              required: true,
              message: 'Пожалуйста, заполните поле',
              trigger: 'change'
            }
          ]
        },
        {
          id: 2,
          placeholder: 'Укажите состав товара',
          model: '',
          label: 'Состав',
          name: 'composition',
          type: 'textarea',
          autosize: { minRows: 1, maxRows: 20 },
          required: true,
          minWidth: '100%',
          prop: [
            {
              required: true,
              message: 'Пожалуйста, заполните поле',
              trigger: 'change'
            }
          ]
        },
        {
          id: 3,
          placeholder: 'Укажите описание товара',
          model: '',
          label: 'Описание товара',
          name: 'description',
          type: 'editor',
          required: true,
          minWidth: '100%',
          prop: [
            {
              required: true,
              message: 'Пожалуйста, заполните поле',
              trigger: 'change'
            }
          ]
        },
        {
          id: 4,
          placeholder: '',
          model: '',
          label: 'Белки',
          name: 'squirrels',
          type: 'text',
          minWidth: ''
        },
        {
          id: 5,
          placeholder: '',
          model: '',
          label: 'Жиры',
          name: 'fat',
          type: 'text',
          minWidth: ''
        },
        {
          id: 6,
          placeholder: '',
          model: '',
          label: 'Углеводы',
          name: 'carbohydrates',
          type: 'text',
          minWidth: ''
        },
        {
          id: 7,
          placeholder: '',
          model: '',
          label: 'Энергетическая ценность',
          name: 'energy',
          type: 'text'
        },
        {
          id: 11,
          placeholder: '',
          model: '',
          label: 'Категория товара',
          name: 'category',
          type: 'select',
          required: true,
          maxWidth: 320,
          prop: [
            {
              required: true,
              message: 'Пожалуйста, выберите категорию',
              trigger: 'change'
            }
          ],
          maxWidth: 320
        },
        {
          id: 12,
          placeholder: '',
          model: '',
          label: 'Cортировка',
          name: 'sort',
          type: 'sort',
          required: true,
          prop: [
            {
              required: true,
              message: 'Пожалуйста, укажите параметры сортировки',
              trigger: 'change'
            }
          ]
        }
      ],
      toolbarConfig: this.$store.state.toolbarNotPhotoVideo,
      pageLoading: false,
      productActive: true
    };
  },
  computed: {
    stateForm() {
      let state = {};
      this.inputs.forEach(item => {
        state[item.name] = this.product[item.name];
      });
      return state;
    },
    rules() {
      let rulesObj = {};
      this.inputs.forEach(item => {
        rulesObj[item.name] = item.prop;
      });
      return rulesObj;
    }
  },
  created() {
    this.$store.commit('pages', [
      {
        name: 'Каталог товаров',
        slug: '/admin/products'
      }
    ]);
    this.$store.commit('headingTitle', 'Товар');
    this.$store.commit('publicLink', `/catalog/product/${this.product.slug}`);
    this.$store.commit('id', this.product.id);
  },
  mounted() {
    this.$axios
      .get('/api/v1/categories/product?id=-1')
      .then(data => {
        data.data.forEach(item => {
          this.options.push({
            label: item.name,
            value: item.slug
          });
        });
      })
      .catch(err => {
        console.log(err);
      });

    this.inputs.forEach(item => {
      item.model = this.product[item.name] || '';
    });
  },
  methods: {
    removePhoto(value) {
      this.deletePhotoPath = value;
      this.product.photo = '';
    },
    elementFormStyle(item) {
      return `${item.maxWidth ? `max-width:${item.maxWidth};` : ''} ${
        item.minWidth ? `min-width:${item.minWidth};` : ''
      } margin-bottom: 35px`;
    },
    changePhoto(value) {
      this.product.photo = value;
    },
    successUpload(response) {
      if (response.photo) {
        this.$axios
          .patch(`/api/v1/products/${this.$route.params.id}`, {
            name: this.stateForm.name,
            composition: this.stateForm.composition,
            description: this.stateForm.description,
            category: this.stateForm.category,
            sort: this.stateForm.sort,
            squirrels: this.stateForm.squirrels,
            fat: this.stateForm.fat,
            carbohydrates: this.stateForm.carbohydrates,
            energy: this.stateForm.energy,
            photo: response.photo,
            active: this.product.active
          })
          .then(
            () => {
              if (this.deletePhotoPath) {
                this.$axios
                  .delete(`/api/v1/img?photo=${this.deletePhotoPath}`)
                  .then(
                    () => {
                      this.deletePhotoPath = '';
                      this.pageLoading = false;
                      this.$message.success('Данные товара успешно изменены!');
                    },
                    err => {
                      this.$message.error(err);
                    }
                  );
              } else {
                this.pageLoading = false;
                this.$message.success('Данные товара успешно изменены!');
              }
            },
            errorMessage => {
              console.log(errorMessage);
              this.$message.error('Ошибка перезаписи данных!');
              this.pageLoading = false;
            }
          )
          .catch(() => {
            this.$message.error('Ошибка перезаписи данных');
            this.pageLoading = false;
          });
      }
    },
    modelValue(valueArr) {
      let index = this.inputs.findIndex(item => item.id === valueArr[0]);
      this.product[this.inputs[index].name] = valueArr[1];
    },
    createNews(formName) {
      this.$refs[formName].validate(valid => {
        if (valid) {
          this.pageLoading = true;
          if (this.deletePhotoPath) {
            this.uploadForm.path = `products/${this.stateForm.category}`;
            this.readyToShip = true;
          } else {
            this.$axios
              .patch(`/api/v1/products/${this.$route.params.id}`, {
                name: this.stateForm.name,
                composition: this.stateForm.composition,
                description: this.stateForm.description,
                category: this.stateForm.category,
                sort: this.stateForm.sort,
                photo: this.stateForm.photo,
                squirrels: this.stateForm.squirrels,
                fat: this.stateForm.fat,
                carbohydrates: this.stateForm.carbohydrates,
                energy: this.stateForm.energy,
                active: this.product.active
              })
              .then(
                data => {
                  this.product = data.data;
                  this.pageLoading = false;
                  this.$message.success('Данные товара успешно изменены!');
                },
                errorMessage => {
                  console.log(errorMessage);
                  this.$message.error('Ошибка перезаписи данных!');
                  this.pageLoading = false;
                }
              )
              .catch(() => {
                this.$message.error('Ошибка перезаписи данных');
                this.pageLoading = false;
              });
          }
        } else {
          this.$message.error('Пожалуйста, заполните все обязательные поля!');
          return false;
        }
      });
    }
  }
};
</script>
